//	UTF-8
//	SPK-FM-301(AR1000) FM Reciever
//
//	MCU:		ATtiny2313
//
//		efuse:0xFF	自己プログラミング不許可
//		hfuse:0x9D	BOD 1.8V チップ消去から EEPROM保護
//		lfuse:0xE2	内蔵CR 4MHz
//
//	Compiler:	AVR-GCC		4.2.2
//				AVR-LIBC	1.4.7
//				binutils	2.18
//
//	2008.10.4	KAWAKAMI Yukio
//

#define		LF	10
#define		CR	13
#define		TAB	9
#define		ESC	27
#define		ON	1
#define		OFF	0

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;


#define		PB7			7		// PORTB
#define		PB6			6
#define		PB5			5
#define		PB4			4
#define		PB3			3
#define		PB2			2
#define		PB1			1
#define		PB0			0

#define		PD6			6		// PORTD
#define		PD5			5
#define		PD4			4
#define		LED			3
#define		BUSEN		2
#define		SCL			1
#define		SDA			0

// TWI(I2C)動作のマクロ設定
#define		SCL_H	\
	DDRD &= ~(1<<SCL);	\
	PORTD |= (1<<SCL)

#define		SCL_L	\
	PORTD &= ~(1<<SCL);		\
	DDRD |= (1<<SCL)

#define		SDA_H	\
	DDRD &= ~(1<<SDA);	\
	PORTD |= (1<<SDA)

#define		SDA_L	\
	PORTD &= ~(1<<SDA);		\
	DDRD |= (1<<SDA)

// SCL=Hになるまで待つ
#define		WAIT_SCL_H	while(!(PIND & (1<<SCL)))
#define		INP_SDA		(PIND & (1<<SDA))

// AR1000 レジスタ
#define	R0		0x00
#define	R1		0x01
#define	R2		0x02
#define	R3		0x03
#define	R4		0x04
#define	R5		0x05
#define	R6		0x06
#define	R7		0x07
#define	R8		0x08
#define	R9		0x09
#define	R10		0x0A
#define	R11		0x0B
#define	R12		0x0C
#define	R13		0x0D
#define	R14		0x0E
#define	R15		0x0F
#define	R16		0x10
#define	R17		0x11
#define	RSSI	0x12
#define	STATUS	0x13
#define	RBS		0x14
#define	RDS1	0x15
#define	RDS2	0x16
#define	RDS3	0x17
#define	RDS4	0x18
#define	RDS5	0x19
#define	RDS6	0x1A
#define	DEVID	0x1B
#define	CHIPID	0x1C

#define	R0_DEFAULT		0xFFFC
#define	R1_DEFAULT		0x5B05
#define	R2_DEFAULT		0xF4B9
#define	R3_DEFAULT		0x9842

#define	R0_ENABLE		0x0001
#define	R0_XO_EN		0x0002
#define	R1_HMUTE		0x0002
#define	R1_SMUTE		0x0004
#define	R1_MONO			0x0008	// ??
#define	R1_DEEMP		0x0010	// ??	1:75us  0:50us
#define	R1_RDS_EN		0x8000	// ??
#define	R2_CHAN			0x01FF
#define	R2_TUNE			0x0200
#define	R3_SEEKTH		0x007F
#define	R3_VOLUMN		0x0780
#define	R3_BAND			0x1800	// 11:76-108	10:76-90	00:87.5-108
#define	R3_SPACE		0x2000
#define	R3_SEEK			0x4000
#define	R3_SEEKUP		0x8000
#define	R14_VOLUME2		0xF000
#define	STATUS_ST		0x0008
#define	STATUS_SF		0x0010	// ???
#define	STATUS_STC		0x0020
#define	STATUS_READCHAN	0xF800

#define	RSSI_MIN_LEVEL	15

void TWI_start(void);
void TWI_send(uchar data);
uchar TWI_recv(uchar ack);
void TWI_stop(void);

void write_AR1000(uchar adrs, ushort data);
ushort read_AR1000(uchar adrs);

void wait_1s(void);
void wait_10ms(uchar w);

